#include <stdio.h>
#include <stdlib.h>
#include <time.h>

typedef struct _node {
   int data;
   struct _node *next;
} node;

node *init ()
{
   node *p;

   p = (node *)malloc(sizeof(node));
   p -> data = 0;
   p -> next = NULL;
   return p;
}

void prnList ( node *head )
{
   node *p;

   p = head -> next;
   printf("(");
   while (p != NULL) {
      printf("%d", p->data);
      p = p -> next;
      if (p == NULL) break;
      printf(",");
   }
   printf(")\n");
}

void insertMid (node *head, int n1, int n2 )
{
   node *p, *q;

   printf("Inserting %2d,%2d: ", n1, n2);
   p = q = head;
   while (p -> next != NULL) {
      p = p -> next -> next;
      q = q -> next;
   }
   p = (node *)malloc(sizeof(node));
   p -> data = n1;
   p -> next = (node *)malloc(sizeof(node));
   p -> next -> data = n2;
   p -> next -> next = q -> next;
   q -> next = p;
}

int main ()
{
   node *head;
   int i;

   srand((unsigned int)time(NULL));
   head = init();
   prnList(head);
   for (i=0; i<20; ++i) {
      insertMid(head, rand()%100, rand()%100);
      prnList(head);
   }

   exit(0);
}
